<?php
namespace Geral\Repositories;

class Pedido extends \Doctrine\ORM\EntityRepository
{
	public function getVrTotalPed($nrorg, $cdfilial, $nrpedido){
		try{
			$sql =" SELECT NVL(I.VRITEM,0)     VRITEM,
                           NVL(I.VRDESITPED,0) VRDESITPED,
                           NVL(E.VRENCARGO,0)  VRENCARGO,
                           NVL(IM.VRIMPOSTO,0) VRIMPOSTO,
                           NVL(I.VRITEM,0) - NVL(I.VRDESITPED,0) + NVL((E.VRENCARGO),0) + NVL((IM.VRIMPOSTO),0) VRTOTAL
                      FROM (SELECT SUM(I.QTITEMPED * I.VRPREUNITPED) VRITEM, SUM(I.VRDESITPED) VRDESITPED
                              FROM ITEMPEDIDO I
                             WHERE I.NRPEDIDO = :P_NRPEDIDO
                               AND I.CDFILIAL = :P_CDFILIAL
                               AND I.NRORG    = :P_NRORG) I,
                           (SELECT SUM(CASE EN.IDENCARGO
                                       WHEN 'A' THEN TO_CHAR(NVL(E.VRENCARGOPED,0))
                                       WHEN 'D' THEN TO_CHAR(NVL(E.VRENCARGOPED,0) * -1)
                                       ELSE '0'
                                        END) VRENCARGO
                              FROM ENCARGOPED E, ENCARGO EN
                             WHERE E.CDENCARGO = EN.CDENCARGO
                               AND E.CDFILIAL  = :P_CDFILIAL
                               AND E.NRPEDIDO  = :P_NRPEDIDO) E,
                           (SELECT SUM(IP.VRACREDESCITPED) AS VRIMPOSTO
                              FROM IMPOSTO IM, IMPITEMPEDIDO IP
                             WHERE IP.CDIMPOSTO = IM.CDIMPOSTO
                               AND IP.CDFILIAL = :P_CDFILIAL
                               AND IP.NRPEDIDO  = :P_NRPEDIDO) IM ";
			$params = array(
				'P_NRORG'    => $nrorg,
				'P_CDFILIAL' => $cdfilial,
				'P_NRPEDIDO' => $nrpedido
			);
			
			return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
			
		}catch(\Exception $e){   
			throw $e;
		}
	}

	public function getQtdeDisp($cdfilial, $cdproduto, $cdalmoxarife, $cdlocalestoq, $nrloteestq, $nrsublote){
		try{
			$sql ="SELECT RE.CDALMOXARIFE, RE.CDLOCALESTOQ, RE.NRLOTEESTQ, RE.NRSUBLOTE, QTDISPONIVEL
					 FROM RESERVAPED RE, LOTE LT
					WHERE RE.CDFILIAL     = :P_CDFILIAL
					  AND RE.CDPRODUTO    = :P_CDPRODUTO
					  AND RE.CDALMOXARIFE = :P_CDALMOXARIFE
					  AND RE.CDLOCALESTOQ = :P_CDLOCALESTOQ
					  AND RE.NRLOTEESTQ   = NVL(:P_NRLOTEESTQ , RE.NRLOTEESTQ)
					  AND RE.NRSUBLOTE    = NVL(:P_NRSUBLOTE  , RE.NRSUBLOTE )
					  AND RE.CDFILIAL     = LT.CDFILIAL   (+)
					  AND RE.NRLOTEESTQ   = LT.NRLOTEESTQ (+)
					  AND RE.NRSUBLOTE    = LT.NRSUBLOTE  (+)
					  AND RE.CDPRODUTO    = LT.CDPRODUTO  (+)
					  AND (TRUNC(LT.DTVALILOTE) >= TRUNC(SYSDATE) OR (LT.DTVALILOTE IS NULL))
				 ORDER BY LT.DTVALILOTE, LT.CDORDENALOTE, LT.DTENTRLOTE, LT.NRLOTEESTQ, LT.NRSUBLOTE";
			$params = array(
				'P_CDFILIAL'     => $cdfilial,
				'P_CDPRODUTO'    => $cdproduto,
				'P_CDALMOXARIFE' => $cdalmoxarife,
				'P_CDLOCALESTOQ' => $cdlocalestoq,
				'P_NRLOTEESTQ'   => $nrloteestq,
				'P_NRSUBLOTE'    => $nrsublote
			);
			
			return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
			
		}catch(\Exception $e){   
			throw $e;
		}
	}

    public function getQtde($cdfilial, $cdproduto, $nrpedido, $nritemped){
        try{
            $sql ="SELECT SUM(RE.QTDISPONIVEL) AS QTDISPONIVEL, AL.CDALMOXARIFE, PR.CDPRODUTO || ' - ' || PR.NMPRODUTO AS CDPRODUTO
					FROM
					   PRODUTO PR, ALMOXARIFADO AL, LOCALESTOQUE LO,
					   LOTE    LT, RESERVAPED RE  , RESERPRODPED RP, FABRICANTE FA, FABRICANTE F
					WHERE RP.NRPEDIDO    (+) = :P_NRPEDIDO
					  AND RP.NRITEMPED   (+) = :P_NRITEMPED
					  AND RP.CDALMOXARIFE(+) = RE.CDALMOXARIFE
					  AND RP.CDLOCALESTOQ(+) = RE.CDLOCALESTOQ
					  AND RP.CDALMOXARIFE(+) = RE.CDALMOXARIFE
					  AND RP.CDLOCALESTOQ(+) = RE.CDLOCALESTOQ
					  AND RP.NRLOTEESTQ  (+) = RE.NRLOTEESTQ
					  AND RP.NRSUBLOTE   (+) = RE.NRSUBLOTE
					  AND RP.CDFILIAL    (+) = RE.CDFILIAL
					  AND RP.CDPRODUTO   (+) = RE.CDPRODUTO
					  AND RE.CDFILIAL     = :P_CDFILIAL
					  AND RE.CDPRODUTO    = :P_CDPRODUTO
					  AND RE.CDPRODUTO    = PR.CDPRODUTO
					  AND (RE.QTDISPONIVEL > 0 OR RP.QTRESPRODPED > 0)
					  AND (TRUNC(LT.DTVALILOTE) >= TRUNC(SYSDATE) OR (LT.DTVALILOTE IS NULL))
					  AND RE.CDFILIAL     = AL.CDFILIAL
					  AND RE.CDALMOXARIFE = AL.CDALMOXARIFE
					  AND RE.CDFILIAL     = LO.CDFILIAL
					  AND RE.CDALMOXARIFE = LO.CDALMOXARIFE
					  AND RE.CDLOCALESTOQ = LO.CDLOCALESTOQ
					  AND LO.IDDISPCONPED = DECODE((SELECT IDUTILALMOX
													  FROM PARAMFILIAL
													 WHERE CDFILIAL = :P_CDFILIAL),'N', LO.IDDISPCONPED, 'S')
					  AND RE.CDFILIAL     = LT.CDFILIAL   (+)
					  AND RE.NRLOTEESTQ   = LT.NRLOTEESTQ (+)
					  AND RE.NRSUBLOTE    = LT.NRSUBLOTE  (+)
					  AND RE.CDPRODUTO    = LT.CDPRODUTO  (+)
					  AND LT.CDFABRIC     = FA.CDFABRIC   (+)
					  AND RP.CDFABRIC     = F.CDFABRIC    (+)
					  AND (LO.CDLOCALESTOQ = DECODE((SELECT IDUTILALMOX
													   FROM PARAMFILIAL
													  WHERE CDFILIAL = :P_CDFILIAL),'N', LO.CDLOCALESTOQ, (SELECT NVL(CDLOCALPRCLI, ' ')
																											 FROM PRODFILI PF
																											WHERE PF.CDFILIAL     = :P_CDFILIAL
																											  AND PF.CDPRODUTO    = :P_CDPRODUTO
																							                  AND PF.CDALMOXPRCLI = LO.CDALMOXARIFE)))
                   GROUP BY AL.CDALMOXARIFE, PR.CDPRODUTO, PR.NMPRODUTO";
            $params = array(
                'P_CDFILIAL'  => $cdfilial,
                'P_CDPRODUTO' => $cdproduto,
                'P_NRPEDIDO'  => $nrpedido,
                'P_NRITEMPED' => $nritemped
            );

            return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

        }catch(\Exception $e){
            throw $e;
            return null;
        }
    }
	
	public function getQtdePed($cdfilial, $cdproduto){
		try{
			$sql ="SELECT SUM(DECODE(IT.IDSITITEMPED, '7',(IT.QTITEMPED - IT.QTEXPITEMPED), (IT.QTITEMPED))) AS QTITEMPED
				     FROM PEDIDO PE, ITEMPEDIDO IT, PRODUTO PR
				    WHERE PE.NRPEDIDO = IT.NRPEDIDO
				      AND   IT.CDPRODUTO = PR.CDPRODUTO
				      AND   IT.CDFILIAL  = PE.CDFILIAL
				      AND PE.IDSITPEDIDO IN ('1', '2', '6')
				      AND IT.IDSITITEMPED IN ('1','2','3','7')
				      AND PR.CDPRODUTO = :P_CDPRODUTO
				      AND PE.CDFILIAL  = :P_CDFILIAL
					 GROUP BY PR.CDPRODUTO";
			$params = array(
				'P_CDFILIAL'  => $cdfilial,
				'P_CDPRODUTO' => $cdproduto
			);
			
			return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
			
		}catch(\Exception $e){
			throw $e;
		}
	}
	
	public function getParamPend($cdfilial, $cdcliente){
		try{
			$sql =" SELECT
					   NVL(C.IDPFINAPRPED,P.IDPENDFINAN) AS IDPENDFINAN,
					   NVL(C.IDSFINAPRPED,P.IDSITUFINAN) AS IDSITUFINAN,
					   P.NRDIAPENDFIN
					FROM
					   CLIENTE C, PARAMPEDIDO P
					WHERE (P.CDFILIAL  = :P_CDFILIAL )
					  AND (C.CDCLIENTE = :P_CDCLIENTE)";
			$params = array(
				'P_CDFILIAL'     => $cdfilial,
				'P_CDCLIENTE'    => $cdcliente
			);
			
			return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
			
		}catch(\Exception $e){   
			throw $e;
		}
	}
	
	public function getPendFinan($cdcliente, $dtlimite){
		try{
			$sql =" SELECT
					   COUNT(CO.DTATUAVENREC) AS PENDENCIA
					FROM
					   CONTARECEBER CO, NOTAFISCAL NF
					WHERE
					   (NF.CDCLIENTE    = :P_CDCLIENTE  ) AND
					   (CO.DTATUAVENREC < :P_DTLIMITE   ) AND
					   (CO.IDSTATREC    IN ('A' , 'D')           ) AND
					   (CO.CDFILIAL     = NF.CDFILIAL   ) AND
					   (CO.NRLANCTONF   = NF.NRLANCTONF ) AND
					   (NF.IDSTATUS IN ('A','E'))";
			$params = array(
				'P_CDCLIENTE'     => $cdcliente,
				'P_DTLIMITE'      => $dtlimite
			);
			
			return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
			
		}catch(\Exception $e){   
			throw $e;
		}
	}
	
}